module     uussbb_color
   ! file:      /home/thomasr/Work/samurai-processes/uussbb/color.f90
   ! generator: haggies (1.1)
   use precision, only: ki
   use uussbb_model, only: TR, NC, Nf
   implicit none
   save

   complex(ki), parameter :: i_ = (0.0_ki, 1.0_ki)
   real(ki), parameter :: pi = &
   & 3.1415926535897932384626433832795028841971693993751058209749445920_ki
   real(ki), parameter :: pi6 = pi*pi/6.0_ki

   private :: i_, pi, pi6
   integer, parameter :: numcs = 6
   complex(ki), dimension(numcs, numcs) :: CC
   complex(ki), dimension(numcs, numcs) :: T1T1
   complex(ki), dimension(numcs, numcs) :: T1T2
   complex(ki), dimension(numcs, numcs) :: T1T3
   complex(ki), dimension(numcs, numcs) :: T1T4
   complex(ki), dimension(numcs, numcs) :: T1T5
   complex(ki), dimension(numcs, numcs) :: T1T6
   complex(ki), dimension(numcs, numcs) :: T2T2
   complex(ki), dimension(numcs, numcs) :: T2T3
   complex(ki), dimension(numcs, numcs) :: T2T4
   complex(ki), dimension(numcs, numcs) :: T2T5
   complex(ki), dimension(numcs, numcs) :: T2T6
   complex(ki), dimension(numcs, numcs) :: T3T3
   complex(ki), dimension(numcs, numcs) :: T3T4
   complex(ki), dimension(numcs, numcs) :: T3T5
   complex(ki), dimension(numcs, numcs) :: T3T6
   complex(ki), dimension(numcs, numcs) :: T4T4
   complex(ki), dimension(numcs, numcs) :: T4T5
   complex(ki), dimension(numcs, numcs) :: T4T6
   complex(ki), dimension(numcs, numcs) :: T5T5
   complex(ki), dimension(numcs, numcs) :: T5T6
   complex(ki), dimension(numcs, numcs) :: T6T6
   real(ki) :: incolors

   real(ki) :: CA, CF, KA, KF, gammaA, gammaF

   ! Basis vectors
   integer, private :: i
   real(ki), dimension(numcs), parameter :: c1 = &
      & (/(0.0_ki, i=1,1-1),1.0_ki,(0.0_ki, i=1+1,6)/)
   real(ki), dimension(numcs), parameter :: c2 = &
      & (/(0.0_ki, i=1,2-1),1.0_ki,(0.0_ki, i=2+1,6)/)
   real(ki), dimension(numcs), parameter :: c3 = &
      & (/(0.0_ki, i=1,3-1),1.0_ki,(0.0_ki, i=3+1,6)/)
   real(ki), dimension(numcs), parameter :: c4 = &
      & (/(0.0_ki, i=1,4-1),1.0_ki,(0.0_ki, i=4+1,6)/)
   real(ki), dimension(numcs), parameter :: c5 = &
      & (/(0.0_ki, i=1,5-1),1.0_ki,(0.0_ki, i=5+1,6)/)
   real(ki), dimension(numcs), parameter :: c6 = &
      & (/(0.0_ki, i=1,6-1),1.0_ki,(0.0_ki, i=6+1,6)/)
   
contains
   subroutine     init_color()
      implicit none
      real(ki) :: NA
      real(ki) :: t1
      real(ki) :: t2
      
      t1 = NC*NC
      NA = (t1-1.0_ki)
      incolors = t1
      t2 = t1*NC
      CC(1, 1) = t2
      CC(1, 1) = t2
      CC(1, 2) = t1
      CC(2, 1) = t1
      CC(1, 3) = NC
      CC(3, 1) = NC
      CC(1, 4) = t1
      CC(4, 1) = t1
      CC(1, 5) = NC
      CC(5, 1) = NC
      CC(1, 6) = t1
      CC(6, 1) = t1
      CC(2, 1) = t1
      CC(1, 2) = t1
      CC(2, 2) = t2
      CC(2, 2) = t2
      CC(2, 3) = t1
      CC(3, 2) = t1
      CC(2, 4) = NC
      CC(4, 2) = NC
      CC(2, 5) = t1
      CC(5, 2) = t1
      CC(2, 6) = NC
      CC(6, 2) = NC
      CC(3, 1) = NC
      CC(1, 3) = NC
      CC(3, 2) = t1
      CC(2, 3) = t1
      CC(3, 3) = t2
      CC(3, 3) = t2
      CC(3, 4) = t1
      CC(4, 3) = t1
      CC(3, 5) = NC
      CC(5, 3) = NC
      CC(3, 6) = t1
      CC(6, 3) = t1
      CC(4, 1) = t1
      CC(1, 4) = t1
      CC(4, 2) = NC
      CC(2, 4) = NC
      CC(4, 3) = t1
      CC(3, 4) = t1
      CC(4, 4) = t2
      CC(4, 4) = t2
      CC(4, 5) = t1
      CC(5, 4) = t1
      CC(4, 6) = NC
      CC(6, 4) = NC
      CC(5, 1) = NC
      CC(1, 5) = NC
      CC(5, 2) = t1
      CC(2, 5) = t1
      CC(5, 3) = NC
      CC(3, 5) = NC
      CC(5, 4) = t1
      CC(4, 5) = t1
      CC(5, 5) = t2
      CC(5, 5) = t2
      CC(5, 6) = t1
      CC(6, 5) = t1
      CC(6, 1) = t1
      CC(1, 6) = t1
      CC(6, 2) = NC
      CC(2, 6) = NC
      CC(6, 3) = t1
      CC(3, 6) = t1
      CC(6, 4) = NC
      CC(4, 6) = NC
      CC(6, 5) = t1
      CC(5, 6) = t1
      CC(6, 6) = t2
      CC(6, 6) = t2
      T1T1(1, 1) = t2
      T1T1(1, 1) = t2
      T1T1(1, 2) = t1
      T1T1(2, 1) = t1
      T1T1(1, 3) = NC
      T1T1(3, 1) = NC
      T1T1(1, 4) = t1
      T1T1(4, 1) = t1
      T1T1(1, 5) = NC
      T1T1(5, 1) = NC
      T1T1(1, 6) = t1
      T1T1(6, 1) = t1
      T1T1(2, 2) = t2
      T1T1(2, 2) = t2
      T1T1(2, 3) = t1
      T1T1(3, 2) = t1
      T1T1(2, 4) = NC
      T1T1(4, 2) = NC
      T1T1(2, 5) = t1
      T1T1(5, 2) = t1
      T1T1(2, 6) = NC
      T1T1(6, 2) = NC
      T1T1(3, 3) = t2
      T1T1(3, 3) = t2
      T1T1(3, 4) = t1
      T1T1(4, 3) = t1
      T1T1(3, 5) = NC
      T1T1(5, 3) = NC
      T1T1(3, 6) = t1
      T1T1(6, 3) = t1
      T1T1(4, 4) = t2
      T1T1(4, 4) = t2
      T1T1(4, 5) = t1
      T1T1(5, 4) = t1
      T1T1(4, 6) = NC
      T1T1(6, 4) = NC
      T1T1(5, 5) = t2
      T1T1(5, 5) = t2
      T1T1(5, 6) = t1
      T1T1(6, 5) = t1
      T1T1(6, 6) = t2
      T1T1(6, 6) = t2
      T1T2(1, 1) = t2
      T1T2(1, 1) = t2
      T1T2(1, 2) = t1
      T1T2(2, 1) = t1
      T1T2(1, 3) = NC
      T1T2(3, 1) = NC
      T1T2(1, 4) = t1
      T1T2(4, 1) = t1
      T1T2(1, 5) = NC
      T1T2(5, 1) = NC
      T1T2(1, 6) = t1
      T1T2(6, 1) = t1
      T1T2(2, 2) = t2
      T1T2(2, 2) = t2
      T1T2(2, 3) = t1
      T1T2(3, 2) = t1
      T1T2(2, 4) = NC
      T1T2(4, 2) = NC
      T1T2(2, 5) = t1
      T1T2(5, 2) = t1
      T1T2(2, 6) = NC
      T1T2(6, 2) = NC
      T1T2(3, 3) = t2
      T1T2(3, 3) = t2
      T1T2(3, 4) = t1
      T1T2(4, 3) = t1
      T1T2(3, 5) = NC
      T1T2(5, 3) = NC
      T1T2(3, 6) = t1
      T1T2(6, 3) = t1
      T1T2(4, 4) = t2
      T1T2(4, 4) = t2
      T1T2(4, 5) = t1
      T1T2(5, 4) = t1
      T1T2(4, 6) = NC
      T1T2(6, 4) = NC
      T1T2(5, 5) = t2
      T1T2(5, 5) = t2
      T1T2(5, 6) = t1
      T1T2(6, 5) = t1
      T1T2(6, 6) = t2
      T1T2(6, 6) = t2
      T1T3(1, 1) = t2
      T1T3(1, 1) = t2
      T1T3(1, 2) = t1
      T1T3(2, 1) = t1
      T1T3(1, 3) = NC
      T1T3(3, 1) = NC
      T1T3(1, 4) = t1
      T1T3(4, 1) = t1
      T1T3(1, 5) = NC
      T1T3(5, 1) = NC
      T1T3(1, 6) = t1
      T1T3(6, 1) = t1
      T1T3(2, 2) = t2
      T1T3(2, 2) = t2
      T1T3(2, 3) = t1
      T1T3(3, 2) = t1
      T1T3(2, 4) = NC
      T1T3(4, 2) = NC
      T1T3(2, 5) = t1
      T1T3(5, 2) = t1
      T1T3(2, 6) = NC
      T1T3(6, 2) = NC
      T1T3(3, 3) = t2
      T1T3(3, 3) = t2
      T1T3(3, 4) = t1
      T1T3(4, 3) = t1
      T1T3(3, 5) = NC
      T1T3(5, 3) = NC
      T1T3(3, 6) = t1
      T1T3(6, 3) = t1
      T1T3(4, 4) = t2
      T1T3(4, 4) = t2
      T1T3(4, 5) = t1
      T1T3(5, 4) = t1
      T1T3(4, 6) = NC
      T1T3(6, 4) = NC
      T1T3(5, 5) = t2
      T1T3(5, 5) = t2
      T1T3(5, 6) = t1
      T1T3(6, 5) = t1
      T1T3(6, 6) = t2
      T1T3(6, 6) = t2
      T1T4(1, 1) = t2
      T1T4(1, 1) = t2
      T1T4(1, 2) = t1
      T1T4(2, 1) = t1
      T1T4(1, 3) = NC
      T1T4(3, 1) = NC
      T1T4(1, 4) = t1
      T1T4(4, 1) = t1
      T1T4(1, 5) = NC
      T1T4(5, 1) = NC
      T1T4(1, 6) = t1
      T1T4(6, 1) = t1
      T1T4(2, 2) = t2
      T1T4(2, 2) = t2
      T1T4(2, 3) = t1
      T1T4(3, 2) = t1
      T1T4(2, 4) = NC
      T1T4(4, 2) = NC
      T1T4(2, 5) = t1
      T1T4(5, 2) = t1
      T1T4(2, 6) = NC
      T1T4(6, 2) = NC
      T1T4(3, 3) = t2
      T1T4(3, 3) = t2
      T1T4(3, 4) = t1
      T1T4(4, 3) = t1
      T1T4(3, 5) = NC
      T1T4(5, 3) = NC
      T1T4(3, 6) = t1
      T1T4(6, 3) = t1
      T1T4(4, 4) = t2
      T1T4(4, 4) = t2
      T1T4(4, 5) = t1
      T1T4(5, 4) = t1
      T1T4(4, 6) = NC
      T1T4(6, 4) = NC
      T1T4(5, 5) = t2
      T1T4(5, 5) = t2
      T1T4(5, 6) = t1
      T1T4(6, 5) = t1
      T1T4(6, 6) = t2
      T1T4(6, 6) = t2
      T1T5(1, 1) = t2
      T1T5(1, 1) = t2
      T1T5(1, 2) = t1
      T1T5(2, 1) = t1
      T1T5(1, 3) = NC
      T1T5(3, 1) = NC
      T1T5(1, 4) = t1
      T1T5(4, 1) = t1
      T1T5(1, 5) = NC
      T1T5(5, 1) = NC
      T1T5(1, 6) = t1
      T1T5(6, 1) = t1
      T1T5(2, 2) = t2
      T1T5(2, 2) = t2
      T1T5(2, 3) = t1
      T1T5(3, 2) = t1
      T1T5(2, 4) = NC
      T1T5(4, 2) = NC
      T1T5(2, 5) = t1
      T1T5(5, 2) = t1
      T1T5(2, 6) = NC
      T1T5(6, 2) = NC
      T1T5(3, 3) = t2
      T1T5(3, 3) = t2
      T1T5(3, 4) = t1
      T1T5(4, 3) = t1
      T1T5(3, 5) = NC
      T1T5(5, 3) = NC
      T1T5(3, 6) = t1
      T1T5(6, 3) = t1
      T1T5(4, 4) = t2
      T1T5(4, 4) = t2
      T1T5(4, 5) = t1
      T1T5(5, 4) = t1
      T1T5(4, 6) = NC
      T1T5(6, 4) = NC
      T1T5(5, 5) = t2
      T1T5(5, 5) = t2
      T1T5(5, 6) = t1
      T1T5(6, 5) = t1
      T1T5(6, 6) = t2
      T1T5(6, 6) = t2
      T1T6(1, 1) = t2
      T1T6(1, 1) = t2
      T1T6(1, 2) = t1
      T1T6(2, 1) = t1
      T1T6(1, 3) = NC
      T1T6(3, 1) = NC
      T1T6(1, 4) = t1
      T1T6(4, 1) = t1
      T1T6(1, 5) = NC
      T1T6(5, 1) = NC
      T1T6(1, 6) = t1
      T1T6(6, 1) = t1
      T1T6(2, 2) = t2
      T1T6(2, 2) = t2
      T1T6(2, 3) = t1
      T1T6(3, 2) = t1
      T1T6(2, 4) = NC
      T1T6(4, 2) = NC
      T1T6(2, 5) = t1
      T1T6(5, 2) = t1
      T1T6(2, 6) = NC
      T1T6(6, 2) = NC
      T1T6(3, 3) = t2
      T1T6(3, 3) = t2
      T1T6(3, 4) = t1
      T1T6(4, 3) = t1
      T1T6(3, 5) = NC
      T1T6(5, 3) = NC
      T1T6(3, 6) = t1
      T1T6(6, 3) = t1
      T1T6(4, 4) = t2
      T1T6(4, 4) = t2
      T1T6(4, 5) = t1
      T1T6(5, 4) = t1
      T1T6(4, 6) = NC
      T1T6(6, 4) = NC
      T1T6(5, 5) = t2
      T1T6(5, 5) = t2
      T1T6(5, 6) = t1
      T1T6(6, 5) = t1
      T1T6(6, 6) = t2
      T1T6(6, 6) = t2
      T2T2(1, 1) = t2
      T2T2(1, 1) = t2
      T2T2(1, 2) = t1
      T2T2(2, 1) = t1
      T2T2(1, 3) = NC
      T2T2(3, 1) = NC
      T2T2(1, 4) = t1
      T2T2(4, 1) = t1
      T2T2(1, 5) = NC
      T2T2(5, 1) = NC
      T2T2(1, 6) = t1
      T2T2(6, 1) = t1
      T2T2(2, 2) = t2
      T2T2(2, 2) = t2
      T2T2(2, 3) = t1
      T2T2(3, 2) = t1
      T2T2(2, 4) = NC
      T2T2(4, 2) = NC
      T2T2(2, 5) = t1
      T2T2(5, 2) = t1
      T2T2(2, 6) = NC
      T2T2(6, 2) = NC
      T2T2(3, 3) = t2
      T2T2(3, 3) = t2
      T2T2(3, 4) = t1
      T2T2(4, 3) = t1
      T2T2(3, 5) = NC
      T2T2(5, 3) = NC
      T2T2(3, 6) = t1
      T2T2(6, 3) = t1
      T2T2(4, 4) = t2
      T2T2(4, 4) = t2
      T2T2(4, 5) = t1
      T2T2(5, 4) = t1
      T2T2(4, 6) = NC
      T2T2(6, 4) = NC
      T2T2(5, 5) = t2
      T2T2(5, 5) = t2
      T2T2(5, 6) = t1
      T2T2(6, 5) = t1
      T2T2(6, 6) = t2
      T2T2(6, 6) = t2
      T2T3(1, 1) = t2
      T2T3(1, 1) = t2
      T2T3(1, 2) = t1
      T2T3(2, 1) = t1
      T2T3(1, 3) = NC
      T2T3(3, 1) = NC
      T2T3(1, 4) = t1
      T2T3(4, 1) = t1
      T2T3(1, 5) = NC
      T2T3(5, 1) = NC
      T2T3(1, 6) = t1
      T2T3(6, 1) = t1
      T2T3(2, 2) = t2
      T2T3(2, 2) = t2
      T2T3(2, 3) = t1
      T2T3(3, 2) = t1
      T2T3(2, 4) = NC
      T2T3(4, 2) = NC
      T2T3(2, 5) = t1
      T2T3(5, 2) = t1
      T2T3(2, 6) = NC
      T2T3(6, 2) = NC
      T2T3(3, 3) = t2
      T2T3(3, 3) = t2
      T2T3(3, 4) = t1
      T2T3(4, 3) = t1
      T2T3(3, 5) = NC
      T2T3(5, 3) = NC
      T2T3(3, 6) = t1
      T2T3(6, 3) = t1
      T2T3(4, 4) = t2
      T2T3(4, 4) = t2
      T2T3(4, 5) = t1
      T2T3(5, 4) = t1
      T2T3(4, 6) = NC
      T2T3(6, 4) = NC
      T2T3(5, 5) = t2
      T2T3(5, 5) = t2
      T2T3(5, 6) = t1
      T2T3(6, 5) = t1
      T2T3(6, 6) = t2
      T2T3(6, 6) = t2
      T2T4(1, 1) = t2
      T2T4(1, 1) = t2
      T2T4(1, 2) = t1
      T2T4(2, 1) = t1
      T2T4(1, 3) = NC
      T2T4(3, 1) = NC
      T2T4(1, 4) = t1
      T2T4(4, 1) = t1
      T2T4(1, 5) = NC
      T2T4(5, 1) = NC
      T2T4(1, 6) = t1
      T2T4(6, 1) = t1
      T2T4(2, 2) = t2
      T2T4(2, 2) = t2
      T2T4(2, 3) = t1
      T2T4(3, 2) = t1
      T2T4(2, 4) = NC
      T2T4(4, 2) = NC
      T2T4(2, 5) = t1
      T2T4(5, 2) = t1
      T2T4(2, 6) = NC
      T2T4(6, 2) = NC
      T2T4(3, 3) = t2
      T2T4(3, 3) = t2
      T2T4(3, 4) = t1
      T2T4(4, 3) = t1
      T2T4(3, 5) = NC
      T2T4(5, 3) = NC
      T2T4(3, 6) = t1
      T2T4(6, 3) = t1
      T2T4(4, 4) = t2
      T2T4(4, 4) = t2
      T2T4(4, 5) = t1
      T2T4(5, 4) = t1
      T2T4(4, 6) = NC
      T2T4(6, 4) = NC
      T2T4(5, 5) = t2
      T2T4(5, 5) = t2
      T2T4(5, 6) = t1
      T2T4(6, 5) = t1
      T2T4(6, 6) = t2
      T2T4(6, 6) = t2
      T2T5(1, 1) = t2
      T2T5(1, 1) = t2
      T2T5(1, 2) = t1
      T2T5(2, 1) = t1
      T2T5(1, 3) = NC
      T2T5(3, 1) = NC
      T2T5(1, 4) = t1
      T2T5(4, 1) = t1
      T2T5(1, 5) = NC
      T2T5(5, 1) = NC
      T2T5(1, 6) = t1
      T2T5(6, 1) = t1
      T2T5(2, 2) = t2
      T2T5(2, 2) = t2
      T2T5(2, 3) = t1
      T2T5(3, 2) = t1
      T2T5(2, 4) = NC
      T2T5(4, 2) = NC
      T2T5(2, 5) = t1
      T2T5(5, 2) = t1
      T2T5(2, 6) = NC
      T2T5(6, 2) = NC
      T2T5(3, 3) = t2
      T2T5(3, 3) = t2
      T2T5(3, 4) = t1
      T2T5(4, 3) = t1
      T2T5(3, 5) = NC
      T2T5(5, 3) = NC
      T2T5(3, 6) = t1
      T2T5(6, 3) = t1
      T2T5(4, 4) = t2
      T2T5(4, 4) = t2
      T2T5(4, 5) = t1
      T2T5(5, 4) = t1
      T2T5(4, 6) = NC
      T2T5(6, 4) = NC
      T2T5(5, 5) = t2
      T2T5(5, 5) = t2
      T2T5(5, 6) = t1
      T2T5(6, 5) = t1
      T2T5(6, 6) = t2
      T2T5(6, 6) = t2
      T2T6(1, 1) = t2
      T2T6(1, 1) = t2
      T2T6(1, 2) = t1
      T2T6(2, 1) = t1
      T2T6(1, 3) = NC
      T2T6(3, 1) = NC
      T2T6(1, 4) = t1
      T2T6(4, 1) = t1
      T2T6(1, 5) = NC
      T2T6(5, 1) = NC
      T2T6(1, 6) = t1
      T2T6(6, 1) = t1
      T2T6(2, 2) = t2
      T2T6(2, 2) = t2
      T2T6(2, 3) = t1
      T2T6(3, 2) = t1
      T2T6(2, 4) = NC
      T2T6(4, 2) = NC
      T2T6(2, 5) = t1
      T2T6(5, 2) = t1
      T2T6(2, 6) = NC
      T2T6(6, 2) = NC
      T2T6(3, 3) = t2
      T2T6(3, 3) = t2
      T2T6(3, 4) = t1
      T2T6(4, 3) = t1
      T2T6(3, 5) = NC
      T2T6(5, 3) = NC
      T2T6(3, 6) = t1
      T2T6(6, 3) = t1
      T2T6(4, 4) = t2
      T2T6(4, 4) = t2
      T2T6(4, 5) = t1
      T2T6(5, 4) = t1
      T2T6(4, 6) = NC
      T2T6(6, 4) = NC
      T2T6(5, 5) = t2
      T2T6(5, 5) = t2
      T2T6(5, 6) = t1
      T2T6(6, 5) = t1
      T2T6(6, 6) = t2
      T2T6(6, 6) = t2
      T3T3(1, 1) = t2
      T3T3(1, 1) = t2
      T3T3(1, 2) = t1
      T3T3(2, 1) = t1
      T3T3(1, 3) = NC
      T3T3(3, 1) = NC
      T3T3(1, 4) = t1
      T3T3(4, 1) = t1
      T3T3(1, 5) = NC
      T3T3(5, 1) = NC
      T3T3(1, 6) = t1
      T3T3(6, 1) = t1
      T3T3(2, 2) = t2
      T3T3(2, 2) = t2
      T3T3(2, 3) = t1
      T3T3(3, 2) = t1
      T3T3(2, 4) = NC
      T3T3(4, 2) = NC
      T3T3(2, 5) = t1
      T3T3(5, 2) = t1
      T3T3(2, 6) = NC
      T3T3(6, 2) = NC
      T3T3(3, 3) = t2
      T3T3(3, 3) = t2
      T3T3(3, 4) = t1
      T3T3(4, 3) = t1
      T3T3(3, 5) = NC
      T3T3(5, 3) = NC
      T3T3(3, 6) = t1
      T3T3(6, 3) = t1
      T3T3(4, 4) = t2
      T3T3(4, 4) = t2
      T3T3(4, 5) = t1
      T3T3(5, 4) = t1
      T3T3(4, 6) = NC
      T3T3(6, 4) = NC
      T3T3(5, 5) = t2
      T3T3(5, 5) = t2
      T3T3(5, 6) = t1
      T3T3(6, 5) = t1
      T3T3(6, 6) = t2
      T3T3(6, 6) = t2
      T3T4(1, 1) = t2
      T3T4(1, 1) = t2
      T3T4(1, 2) = t1
      T3T4(2, 1) = t1
      T3T4(1, 3) = NC
      T3T4(3, 1) = NC
      T3T4(1, 4) = t1
      T3T4(4, 1) = t1
      T3T4(1, 5) = NC
      T3T4(5, 1) = NC
      T3T4(1, 6) = t1
      T3T4(6, 1) = t1
      T3T4(2, 2) = t2
      T3T4(2, 2) = t2
      T3T4(2, 3) = t1
      T3T4(3, 2) = t1
      T3T4(2, 4) = NC
      T3T4(4, 2) = NC
      T3T4(2, 5) = t1
      T3T4(5, 2) = t1
      T3T4(2, 6) = NC
      T3T4(6, 2) = NC
      T3T4(3, 3) = t2
      T3T4(3, 3) = t2
      T3T4(3, 4) = t1
      T3T4(4, 3) = t1
      T3T4(3, 5) = NC
      T3T4(5, 3) = NC
      T3T4(3, 6) = t1
      T3T4(6, 3) = t1
      T3T4(4, 4) = t2
      T3T4(4, 4) = t2
      T3T4(4, 5) = t1
      T3T4(5, 4) = t1
      T3T4(4, 6) = NC
      T3T4(6, 4) = NC
      T3T4(5, 5) = t2
      T3T4(5, 5) = t2
      T3T4(5, 6) = t1
      T3T4(6, 5) = t1
      T3T4(6, 6) = t2
      T3T4(6, 6) = t2
      T3T5(1, 1) = t2
      T3T5(1, 1) = t2
      T3T5(1, 2) = t1
      T3T5(2, 1) = t1
      T3T5(1, 3) = NC
      T3T5(3, 1) = NC
      T3T5(1, 4) = t1
      T3T5(4, 1) = t1
      T3T5(1, 5) = NC
      T3T5(5, 1) = NC
      T3T5(1, 6) = t1
      T3T5(6, 1) = t1
      T3T5(2, 2) = t2
      T3T5(2, 2) = t2
      T3T5(2, 3) = t1
      T3T5(3, 2) = t1
      T3T5(2, 4) = NC
      T3T5(4, 2) = NC
      T3T5(2, 5) = t1
      T3T5(5, 2) = t1
      T3T5(2, 6) = NC
      T3T5(6, 2) = NC
      T3T5(3, 3) = t2
      T3T5(3, 3) = t2
      T3T5(3, 4) = t1
      T3T5(4, 3) = t1
      T3T5(3, 5) = NC
      T3T5(5, 3) = NC
      T3T5(3, 6) = t1
      T3T5(6, 3) = t1
      T3T5(4, 4) = t2
      T3T5(4, 4) = t2
      T3T5(4, 5) = t1
      T3T5(5, 4) = t1
      T3T5(4, 6) = NC
      T3T5(6, 4) = NC
      T3T5(5, 5) = t2
      T3T5(5, 5) = t2
      T3T5(5, 6) = t1
      T3T5(6, 5) = t1
      T3T5(6, 6) = t2
      T3T5(6, 6) = t2
      T3T6(1, 1) = t2
      T3T6(1, 1) = t2
      T3T6(1, 2) = t1
      T3T6(2, 1) = t1
      T3T6(1, 3) = NC
      T3T6(3, 1) = NC
      T3T6(1, 4) = t1
      T3T6(4, 1) = t1
      T3T6(1, 5) = NC
      T3T6(5, 1) = NC
      T3T6(1, 6) = t1
      T3T6(6, 1) = t1
      T3T6(2, 2) = t2
      T3T6(2, 2) = t2
      T3T6(2, 3) = t1
      T3T6(3, 2) = t1
      T3T6(2, 4) = NC
      T3T6(4, 2) = NC
      T3T6(2, 5) = t1
      T3T6(5, 2) = t1
      T3T6(2, 6) = NC
      T3T6(6, 2) = NC
      T3T6(3, 3) = t2
      T3T6(3, 3) = t2
      T3T6(3, 4) = t1
      T3T6(4, 3) = t1
      T3T6(3, 5) = NC
      T3T6(5, 3) = NC
      T3T6(3, 6) = t1
      T3T6(6, 3) = t1
      T3T6(4, 4) = t2
      T3T6(4, 4) = t2
      T3T6(4, 5) = t1
      T3T6(5, 4) = t1
      T3T6(4, 6) = NC
      T3T6(6, 4) = NC
      T3T6(5, 5) = t2
      T3T6(5, 5) = t2
      T3T6(5, 6) = t1
      T3T6(6, 5) = t1
      T3T6(6, 6) = t2
      T3T6(6, 6) = t2
      T4T4(1, 1) = t2
      T4T4(1, 1) = t2
      T4T4(1, 2) = t1
      T4T4(2, 1) = t1
      T4T4(1, 3) = NC
      T4T4(3, 1) = NC
      T4T4(1, 4) = t1
      T4T4(4, 1) = t1
      T4T4(1, 5) = NC
      T4T4(5, 1) = NC
      T4T4(1, 6) = t1
      T4T4(6, 1) = t1
      T4T4(2, 2) = t2
      T4T4(2, 2) = t2
      T4T4(2, 3) = t1
      T4T4(3, 2) = t1
      T4T4(2, 4) = NC
      T4T4(4, 2) = NC
      T4T4(2, 5) = t1
      T4T4(5, 2) = t1
      T4T4(2, 6) = NC
      T4T4(6, 2) = NC
      T4T4(3, 3) = t2
      T4T4(3, 3) = t2
      T4T4(3, 4) = t1
      T4T4(4, 3) = t1
      T4T4(3, 5) = NC
      T4T4(5, 3) = NC
      T4T4(3, 6) = t1
      T4T4(6, 3) = t1
      T4T4(4, 4) = t2
      T4T4(4, 4) = t2
      T4T4(4, 5) = t1
      T4T4(5, 4) = t1
      T4T4(4, 6) = NC
      T4T4(6, 4) = NC
      T4T4(5, 5) = t2
      T4T4(5, 5) = t2
      T4T4(5, 6) = t1
      T4T4(6, 5) = t1
      T4T4(6, 6) = t2
      T4T4(6, 6) = t2
      T4T5(1, 1) = t2
      T4T5(1, 1) = t2
      T4T5(1, 2) = t1
      T4T5(2, 1) = t1
      T4T5(1, 3) = NC
      T4T5(3, 1) = NC
      T4T5(1, 4) = t1
      T4T5(4, 1) = t1
      T4T5(1, 5) = NC
      T4T5(5, 1) = NC
      T4T5(1, 6) = t1
      T4T5(6, 1) = t1
      T4T5(2, 2) = t2
      T4T5(2, 2) = t2
      T4T5(2, 3) = t1
      T4T5(3, 2) = t1
      T4T5(2, 4) = NC
      T4T5(4, 2) = NC
      T4T5(2, 5) = t1
      T4T5(5, 2) = t1
      T4T5(2, 6) = NC
      T4T5(6, 2) = NC
      T4T5(3, 3) = t2
      T4T5(3, 3) = t2
      T4T5(3, 4) = t1
      T4T5(4, 3) = t1
      T4T5(3, 5) = NC
      T4T5(5, 3) = NC
      T4T5(3, 6) = t1
      T4T5(6, 3) = t1
      T4T5(4, 4) = t2
      T4T5(4, 4) = t2
      T4T5(4, 5) = t1
      T4T5(5, 4) = t1
      T4T5(4, 6) = NC
      T4T5(6, 4) = NC
      T4T5(5, 5) = t2
      T4T5(5, 5) = t2
      T4T5(5, 6) = t1
      T4T5(6, 5) = t1
      T4T5(6, 6) = t2
      T4T5(6, 6) = t2
      T4T6(1, 1) = t2
      T4T6(1, 1) = t2
      T4T6(1, 2) = t1
      T4T6(2, 1) = t1
      T4T6(1, 3) = NC
      T4T6(3, 1) = NC
      T4T6(1, 4) = t1
      T4T6(4, 1) = t1
      T4T6(1, 5) = NC
      T4T6(5, 1) = NC
      T4T6(1, 6) = t1
      T4T6(6, 1) = t1
      T4T6(2, 2) = t2
      T4T6(2, 2) = t2
      T4T6(2, 3) = t1
      T4T6(3, 2) = t1
      T4T6(2, 4) = NC
      T4T6(4, 2) = NC
      T4T6(2, 5) = t1
      T4T6(5, 2) = t1
      T4T6(2, 6) = NC
      T4T6(6, 2) = NC
      T4T6(3, 3) = t2
      T4T6(3, 3) = t2
      T4T6(3, 4) = t1
      T4T6(4, 3) = t1
      T4T6(3, 5) = NC
      T4T6(5, 3) = NC
      T4T6(3, 6) = t1
      T4T6(6, 3) = t1
      T4T6(4, 4) = t2
      T4T6(4, 4) = t2
      T4T6(4, 5) = t1
      T4T6(5, 4) = t1
      T4T6(4, 6) = NC
      T4T6(6, 4) = NC
      T4T6(5, 5) = t2
      T4T6(5, 5) = t2
      T4T6(5, 6) = t1
      T4T6(6, 5) = t1
      T4T6(6, 6) = t2
      T4T6(6, 6) = t2
      T5T5(1, 1) = t2
      T5T5(1, 1) = t2
      T5T5(1, 2) = t1
      T5T5(2, 1) = t1
      T5T5(1, 3) = NC
      T5T5(3, 1) = NC
      T5T5(1, 4) = t1
      T5T5(4, 1) = t1
      T5T5(1, 5) = NC
      T5T5(5, 1) = NC
      T5T5(1, 6) = t1
      T5T5(6, 1) = t1
      T5T5(2, 2) = t2
      T5T5(2, 2) = t2
      T5T5(2, 3) = t1
      T5T5(3, 2) = t1
      T5T5(2, 4) = NC
      T5T5(4, 2) = NC
      T5T5(2, 5) = t1
      T5T5(5, 2) = t1
      T5T5(2, 6) = NC
      T5T5(6, 2) = NC
      T5T5(3, 3) = t2
      T5T5(3, 3) = t2
      T5T5(3, 4) = t1
      T5T5(4, 3) = t1
      T5T5(3, 5) = NC
      T5T5(5, 3) = NC
      T5T5(3, 6) = t1
      T5T5(6, 3) = t1
      T5T5(4, 4) = t2
      T5T5(4, 4) = t2
      T5T5(4, 5) = t1
      T5T5(5, 4) = t1
      T5T5(4, 6) = NC
      T5T5(6, 4) = NC
      T5T5(5, 5) = t2
      T5T5(5, 5) = t2
      T5T5(5, 6) = t1
      T5T5(6, 5) = t1
      T5T5(6, 6) = t2
      T5T5(6, 6) = t2
      T5T6(1, 1) = t2
      T5T6(1, 1) = t2
      T5T6(1, 2) = t1
      T5T6(2, 1) = t1
      T5T6(1, 3) = NC
      T5T6(3, 1) = NC
      T5T6(1, 4) = t1
      T5T6(4, 1) = t1
      T5T6(1, 5) = NC
      T5T6(5, 1) = NC
      T5T6(1, 6) = t1
      T5T6(6, 1) = t1
      T5T6(2, 2) = t2
      T5T6(2, 2) = t2
      T5T6(2, 3) = t1
      T5T6(3, 2) = t1
      T5T6(2, 4) = NC
      T5T6(4, 2) = NC
      T5T6(2, 5) = t1
      T5T6(5, 2) = t1
      T5T6(2, 6) = NC
      T5T6(6, 2) = NC
      T5T6(3, 3) = t2
      T5T6(3, 3) = t2
      T5T6(3, 4) = t1
      T5T6(4, 3) = t1
      T5T6(3, 5) = NC
      T5T6(5, 3) = NC
      T5T6(3, 6) = t1
      T5T6(6, 3) = t1
      T5T6(4, 4) = t2
      T5T6(4, 4) = t2
      T5T6(4, 5) = t1
      T5T6(5, 4) = t1
      T5T6(4, 6) = NC
      T5T6(6, 4) = NC
      T5T6(5, 5) = t2
      T5T6(5, 5) = t2
      T5T6(5, 6) = t1
      T5T6(6, 5) = t1
      T5T6(6, 6) = t2
      T5T6(6, 6) = t2
      T6T6(1, 1) = t2
      T6T6(1, 1) = t2
      T6T6(1, 2) = t1
      T6T6(2, 1) = t1
      T6T6(1, 3) = NC
      T6T6(3, 1) = NC
      T6T6(1, 4) = t1
      T6T6(4, 1) = t1
      T6T6(1, 5) = NC
      T6T6(5, 1) = NC
      T6T6(1, 6) = t1
      T6T6(6, 1) = t1
      T6T6(2, 2) = t2
      T6T6(2, 2) = t2
      T6T6(2, 3) = t1
      T6T6(3, 2) = t1
      T6T6(2, 4) = NC
      T6T6(4, 2) = NC
      T6T6(2, 5) = t1
      T6T6(5, 2) = t1
      T6T6(2, 6) = NC
      T6T6(6, 2) = NC
      T6T6(3, 3) = t2
      T6T6(3, 3) = t2
      T6T6(3, 4) = t1
      T6T6(4, 3) = t1
      T6T6(3, 5) = NC
      T6T6(5, 3) = NC
      T6T6(3, 6) = t1
      T6T6(6, 3) = t1
      T6T6(4, 4) = t2
      T6T6(4, 4) = t2
      T6T6(4, 5) = t1
      T6T6(5, 4) = t1
      T6T6(4, 6) = NC
      T6T6(6, 4) = NC
      T6T6(5, 5) = t2
      T6T6(5, 5) = t2
      T6T6(5, 6) = t1
      T6T6(6, 5) = t1
      T6T6(6, 6) = t2
      T6T6(6, 6) = t2

      CA = NC
      CF = TR * NA / NC
      ! KA = Kg in (C.11) [Catani,Seymour]
      KA = (67.0_ki/18.0_ki - pi6) * CA &
         & - 10.0_ki/9.0_ki * TR * Nf
      ! KF = Kq in (C.11) [Catani,Seymour]
      KF = (3.5_ki - pi6) * CF
      ! gammaA = \gamma_g in (C.11) [Catani,Seymour]
      gammaA = 11.0_ki/6.0_ki * CA - 2.0_ki/3.0_ki * TR * Nf
      ! gammaF = \gamma_q in (C.11) [Catani,Seymour]
      gammaF = 1.5_ki * CF
   end subroutine init_color
   subroutine     inspect_color(unit)
      implicit none
      integer, intent(in) :: unit
      integer :: i, j
      character :: ch1, ch2, ch3

      ch3 = ","
      write (unit,'(A13)') "golem_color=["
      do i=1,numcs
         do j=1,numcs
	    if (j==1) then
	       ch1 = "["
	    else
	       ch1 = " "
	    endif

	    if (j == numcs) then
	       ch2 = "]"
               if (i == numcs) then
                  ch3 = "]"
               end if
	    else
	       ch2 = ","
	    end if

	    if (j == numcs) then
               write (unit,'(3x,A1,A8,G22.16,A1,G22.16,A1,A1,A1)') &
               & ch1, "complex(", real(CC(i,j)), ",", aimag(CC(i,j)), ")", &
               & ch2, ch3
            else
               write (unit,'(3x,A1,A8,G22.16,A1,G22.16,A1,A1)') &
               & ch1, "complex(", real(CC(i,j)), ",", aimag(CC(i,j)), ")", &
               & ch2
            end if
         enddo
      enddo
   end subroutine inspect_color
end module uussbb_color
