module madds
   use precision, only: ki, ki_avh, ki_ql, ki_lt
!AC!use precision_golem, only: ki_gol => ki
   use constants
   use options
   use mfunctions
   use notfirst
   implicit none

   private

     interface
        subroutine avh_olo_d0m(rslt,p1,p2,p3,p4,p12,p23,m1,m2,m3,m4)
           use precision, only: ki_avh
           implicit none
           complex(ki_avh), intent(out) :: rslt(0:2)
           real(ki_avh), intent(in) :: p1,p2,p3,p4,p12,p23,m1,m2,m3,m4
        end subroutine avh_olo_d0m
     end interface
     interface
        subroutine avh_olo_c0m(rslt,p1,p2,p3,m1,m2,m3)
           use precision, only: ki_avh
           implicit none
           complex(ki_avh), intent(out) :: rslt(0:2)
           real(ki_avh), intent(in) :: p1,p2,p3,m1,m2,m3
        end subroutine avh_olo_c0m
     end interface
     interface
        subroutine avh_olo_b11m(b11,b00,b1,b0,pp,m1,m2)
           use precision, only: ki_avh
           implicit none
           complex(ki_avh), intent(out) :: b11(0:2), b00(0:2), b1(0:2), b0(0:2)
           real(ki_avh), intent(in) :: pp,m1,m2
        end subroutine avh_olo_b11m
     end interface
     interface
        subroutine avh_olo_a0m(rslt,mm)
           use precision, only: ki_avh
           implicit none
           complex(ki_avh), intent(out) :: rslt(0:2)
           real(ki_avh), intent(in) :: mm
        end subroutine avh_olo_a0m
     end interface

     interface
        function qlI4(p1,p2,p3,p4,s12,s23,m1,m2,m3,m4,mu2,ep)
           use precision, only: ki_ql
           implicit none
           real(ki_ql), intent(in) :: p1,p2,p3,p4,s12,s23
           real(ki_ql), intent(in) :: m1,m2,m3,m4,mu2
           integer, intent(in) :: ep
           complex(ki_ql) :: qlI4
        end function qlI4
     end interface
     interface
        function qlI3(p1,p2,p3,m1,m2,m3,mu2,ep)
           use precision, only: ki_ql
           implicit none
           real(ki_ql), intent(in) :: p1,p2,p3
           real(ki_ql), intent(in) :: m1,m2,m3,mu2
           integer, intent(in) :: ep
           complex(ki_ql) :: qlI3
        end function qlI3
     end interface
     interface
        function qlI2(p1,m1,m2,mu2,ep)
           use precision, only: ki_ql
           implicit none
           real(ki_ql), intent(in) :: p1
           real(ki_ql), intent(in) :: m1,m2,mu2
           integer, intent(in) :: ep
           complex(ki_ql) :: qlI2
        end function qlI2
     end interface
     interface
        function qlI1(m1,mu2,ep)
           use precision, only: ki_ql
           implicit none
           real(ki_ql), intent(in) :: m1,mu2
           integer, intent(in) :: ep
           complex(ki_ql) :: qlI1
        end function qlI1
     end interface

!AC!     interface
!AC!        function gD0(p1,p2,p3,p4,s12,s23,m1,m2,m3,m4,mu2,ep)
!AC!           use precision_golem, only: ki
!AC!           implicit none
!AC!           real(ki), intent(in) :: p1,p2,p3,p4,s12,s23
!AC!           real(ki), intent(in) :: m1,m2,m3,m4
!AC!           real(ki), intent(in) :: mu2
!AC!           integer, intent(in) :: ep
!AC!           complex(ki) :: gD0
!AC!        end function gD0
!AC!     end interface
!AC!     interface
!AC!        function gC0(p1,p2,p3,m1,m2,m3,mu2,ep)
!AC!           use precision_golem, only: ki
!AC!           implicit none
!AC!           real(ki), intent(in) :: p1,p2,p3
!AC!           real(ki), intent(in) :: m1,m2,m3
!AC!           real(ki), intent(in) :: mu2
!AC!           integer, intent(in) :: ep
!AC!           complex(ki) :: gC0
!AC!        end function gC0
!AC!     end interface
!AC!     interface
!AC!        function gB0(p1,m1,m2,mu2,ep)
!AC!           use precision_golem, only: ki
!AC!           implicit none
!AC!           real(ki), intent(in) :: p1
!AC!           real(ki), intent(in) :: m1,m2
!AC!           real(ki), intent(in) :: mu2
!AC!           integer, intent(in) :: ep
!AC!           complex(ki) :: gB0
!AC!        end function gB0
!AC!     end interface

!AC!     interface
!AC!        function D0(p1,p2,p3,p4,s12,s23,m1,m2,m3,m4)
!AC!           use precision, only: ki_lt
!AC!           implicit none
!AC!           real(ki_lt), intent(in) :: p1,p2,p3,p4,s12,s23
!AC!           real(ki_lt), intent(in) :: m1,m2,m3,m4
!AC!           complex(ki_lt) :: D0
!AC!        end function D0
!AC!     end interface
!AC!     interface
!AC!        function C0(p1,p2,p3,m1,m2,m3)
!AC!           use precision, only: ki_lt
!AC!           implicit none
!AC!           real(ki_lt), intent(in) :: p1,p2,p3
!AC!           real(ki_lt), intent(in) :: m1,m2,m3
!AC!           complex(ki_lt) :: C0
!AC!        end function C0
!AC!     end interface
!AC!     interface
!AC!        function B0(p1,m1,m2)
!AC!           use precision, only: ki_lt
!AC!           implicit none
!AC!           real(ki_lt), intent(in) :: p1
!AC!           real(ki_lt), intent(in) :: m1,m2
!AC!           complex(ki_lt) :: B0
!AC!        end function B0
!AC!     end interface
!AC!     interface
!AC!        function B1(p1,m1,m2)
!AC!           use precision, only: ki_lt
!AC!           implicit none
!AC!           real(ki_lt), intent(in) :: p1
!AC!           real(ki_lt), intent(in) :: m1,m2
!AC!           complex(ki_lt) :: B1
!AC!        end function B1
!AC!     end interface
!AC!     interface
!AC!        function B00(p1,m1,m2)
!AC!           use precision, only: ki_lt
!AC!           implicit none
!AC!           real(ki_lt), intent(in) :: p1
!AC!           real(ki_lt), intent(in) :: m1,m2
!AC!           complex(ki_lt) :: B00
!AC!        end function B00
!AC!     end interface
!AC!     interface
!AC!        function B11(p1,m1,m2)
!AC!           use precision, only: ki_lt
!AC!           implicit none
!AC!           real(ki_lt), intent(in) :: p1
!AC!           real(ki_lt), intent(in) :: m1,m2
!AC!           complex(ki_lt) :: B11
!AC!        end function B11
!AC!     end interface
!AC!     interface
!AC!        function A0(m1)
!AC!           use precision, only: ki_lt
!AC!           implicit none
!AC!           real(ki_lt), intent(in) :: m1
!AC!           complex(ki_lt) :: A0
!AC!        end function A0
!AC!     end interface
!AC!     interface
!AC!        function getlambda()
!AC!           use precision, only: ki_lt
!AC!           implicit none
!AC!           real(ki_lt) :: getlambda
!AC!        end function getlambda
!AC!     end interface

   public :: add4, add3, add2, add1
contains

  subroutine add4(nleg,c4,cut4,Vi,msq,tot4,tot4r,scale2)
      implicit none
      integer cut4,i,j1,j2,j3,j4,nleg
      real(ki), dimension(0:nleg-1):: msq
      real(ki), dimension(0:nleg-1,4) ::Vi
      real(ki) :: scale2, m0, m1, m2, m3, V1, V2, V3, V21, V31, V32
      real(ki), dimension(4):: Vi1, Vi2, Vi3, Vi21, Vi31, Vi32
      complex(ki), dimension(-2:0), intent(out) :: tot4
      complex(ki), dimension(0:4), intent(in) :: c4
      complex(ki), intent(out) :: tot4r
      complex(ki) :: c40
          complex(ki_avh), dimension(0:2) :: vald0
      complex(ki) :: ctmp
!AC!      complex(ki), dimension(-2:0) :: d0t
      integer :: ep

      if (isca .eq. 2) then
       if (notfirsti.eqv.(.false.)) then
             call avh_olo_mu_set(real(sqrt(scale2),ki_avh))
         notfirsti=.true.
       endif
      endif

      j4=cut4/1000
      j3=(cut4-j4*1000)/100
      j2=(cut4-j4*1000-j3*100)/10
      j1=cut4-j4*1000-j3*100-j2*10

      m0=msq(j1)
      m1=msq(j2)
      m2=msq(j3)
      m3=msq(j4)

      Vi1(:)=Vi(j2,:)-Vi(j1,:)
      Vi2(:)=Vi(j3,:)-Vi(j1,:)
      Vi3(:)=Vi(j1,:)-Vi(j4,:)
      Vi21(:)=Vi(j3,:)-Vi(j2,:)
      Vi31(:)=Vi(j4,:)-Vi(j2,:)
      Vi32(:)=Vi(j4,:)-Vi(j3,:)

      V1=sdot(Vi1,Vi1)
      V2=sdot(Vi2,Vi2)
      V3=sdot(Vi3,Vi3)
      V21=sdot(Vi21,Vi21)
      V31=sdot(Vi31,Vi31)
      V32=sdot(Vi32,Vi32)

      c40=c4(0)
      tot4r=-c4(4)/six

  1  Format(A3,I4,A1,I2,A5,D24.15,A1,D24.15,A3)

      if     (isca.eq.1) then
          do ep=-2,0
             ctmp=qlI4(real(V1,ki_ql),real(V21,ki_ql),real(V32,ki_ql),&
             &         real(V3,ki_ql),real(V2,ki_ql),real(V31,ki_ql),&
             &         real(m0,ki_ql),real(m1,ki_ql),real(m2,ki_ql),&
             &         real(m3,ki_ql),real(scale2,ki_ql),ep)
                  tot4(ep)=c40*ctmp
             tot4(ep)=c40*ctmp
             if (verbosity.ge.2) write(iout,1) &
         & 'I4(',cut4,',',ep,') = (',real(ctmp),',',aimag(ctmp),'  )' 
          enddo
!AC!      print*, "isca=1: QCDLoop not available"
!AC!      stop
      elseif (isca.eq.2) then
             call avh_olo_d0m(vald0,&
             &                real(V1,ki_avh),real(V21,ki_avh),real(V32,ki_avh),&
             &                real(V3,ki_avh),real(V2,ki_avh),real(V31,ki_avh),&
             &                real(m0,ki_avh),real(m1,ki_avh),real(m2,ki_avh),&
             &                real(m3,ki_avh))
             do ep=-2,0
                tot4(ep)= c40*vald0(-ep) 
                if (verbosity.ge.2) write(iout,1) &
                & 'I4(',cut4,',',ep,') = (',real(vald0(-ep)),',',aimag(vald0(-ep)),'  )' 
             enddo
!AC!      print*, "isca=2: OneLOop not available"
!AC!      stop
      elseif (isca.eq.3) then
!AC!        call gtrunc(abs(V32)+abs(V31), V1,V2,V3,V21,V32,V31,m0,m1,m2,m3)
!AC!        do ep=-2,0
!AC!           d0t(ep)=gD0(real(V1,ki_gol),real(V21,ki_gol),&
!AC!           &        real(V32,ki_gol),real(V3,ki_gol),&
!AC!           &        real(V2,ki_gol),real(V31,ki_gol),&
!AC!           &        real(m0,ki_gol),real(m1,ki_gol),&
!AC!           &        real(m2,ki_gol),real(m3,ki_gol),&
!AC!           &        real(scale2,ki_gol),ep)
!AC!        end do
!AC!        !d0t( 0) = d0t(0) + log(scale2) * (d0t(-1) &
!AC!        !      & + 0.5_ki * log(scale2) * d0t(-2))
!AC!        !d0t(-1) = d0t(-1) + log(scale2) * d0t(-2)
!AC!        do ep=-2,0
!AC!           if (verbosity.ge.2) write(iout,1) 'I4(',cut4,',',ep,&
!AC!             & ') = (',real(d0t(ep)),',',aimag(d0t(ep)),'  )' 
!AC!        end do
!AC!        tot4(:) = d0t(:) * c40
            print*, "isca=3: Golem95 not available"
            stop
      elseif (isca.eq.4) then
!AC!        tot4(-2) = 0
!AC!        tot4(-1) = 0
!AC!        tot4(0) = 0
!AC!        ep = -dim(0, int(getlambda()))
!AC!        call gtrunc(abs(V32)+abs(V31), V1,V2,V3,V21,V32,V31,m0,m1,m2,m3)
!AC!        ctmp=D0(real(V1,ki_lt),real(V21,ki_lt),real(V32,ki_lt),&
!AC!        &       real(V3,ki_lt),real(V2,ki_lt),real(V31,ki_lt),&
!AC!        &       real(m0,ki_lt),real(m1,ki_lt),real(m2,ki_lt),&
!AC!        &       real(m3,ki_lt))
!AC!        tot4(ep)=c40*ctmp
!AC!        if (verbosity.ge.2) write(iout,1) &
!AC!     & 'I4(',cut4,',',ep,') = (',real(ctmp),',',aimag(ctmp),'  )' 
             print*, "isca=4: LoopTools not available"
             stop
      else
         print*, 'error in add4'
         stop
      endif
      tot4(0)=tot4(0) + tot4r
  end subroutine add4

  subroutine add3(nleg,c3,cut3,Vi,msq,tot3,tot3r,scale2)
      implicit none
      integer cut3,i,j1,j2,j3,nleg
      real(ki), dimension(0:nleg-1):: msq
      real(ki), dimension(0:nleg-1,4) ::Vi
      real(ki) :: scale2, m0, m1, m2, V1, V2, V3
      real(ki), dimension(4):: Vi1, Vi2, Vi3
      complex(ki), dimension(-2:0), intent(out) :: tot3
      complex(ki), dimension(0:9), intent(in) :: c3
      complex(ki), intent(out) :: tot3r
      complex(ki) :: c30
          complex(ki_avh), dimension(0:2) :: valc0
      complex(ki) :: ctmp
!AC!      complex(ki), dimension(-2:0) :: c0t
      integer :: ep

      if (isca .eq. 2) then
       if (notfirsti.eqv.(.false.)) then
             call avh_olo_mu_set(real(sqrt(scale2),ki_avh))
         notfirsti=.true.
       endif
      endif

      j3=cut3/100
      j2=(cut3-j3*100)/10
      j1=cut3-j3*100-j2*10

      m0=msq(j1)
      m1=msq(j2)
      m2=msq(j3)

      do i=1,4
         Vi1(i)=Vi(j2,i)-Vi(j1,i)
         Vi2(i)=Vi(j3,i)-Vi(j2,i)
         Vi3(i)=Vi(j1,i)-Vi(j3,i)
      enddo

      V1=sdot(Vi1,Vi1)
      V2=sdot(Vi2,Vi2)
      V3=sdot(Vi3,Vi3)

      c30=c3(0)

      tot3r=+c3(7)/two

  1  Format(A3,I3,A1,I2,A5,D24.15,A1,D24.15,A3)

      if (isca.eq.1) then
          do ep=-2,0
             ctmp=qlI3(real(V1,ki_ql),real(V2,ki_ql),real(V3,ki_ql),&
             &         real(m0,ki_ql),real(m1,ki_ql),real(m2,ki_ql),&
             &         real(scale2,ki_ql),ep)
             tot3(ep)=c30*ctmp 
             if (verbosity.ge.2) then
                write(iout,1) &
               &  'I3(',cut3,',',ep,') = (',&
               &  real(ctmp),',',aimag(ctmp),'  )' 
                write(iout,*) abs(ctmp), V1, V2, V3, m0, m1, m2
             end if
          enddo
!AC!      print*, "isca=1: QCDLoop not available"
!AC!      stop
      elseif  (isca.eq.2) then
              call avh_olo_c0m(valc0,real(V1,ki_avh),real(V2,ki_avh),real(V3,ki_avh),&
              &                real(m0,ki_avh),real(m1,ki_avh),real(m2,ki_avh))
              do ep=-2,0
                 tot3(ep)= c30*valc0(-ep) 
                 if (verbosity.ge.2) write(iout,1) &
         &'I3(',cut3,',',ep,') = (',real(valc0(-ep)),',',aimag(valc0(-ep)),'  )' 
              enddo
!AC!      print*, "isca=2: OneLOop not available"
!AC!      stop
      elseif (isca.eq.3) then
!AC!        call gtrunc(abs(V1)+abs(V2)+abs(V3), V1,V2,V3,m0,m1,m2)
!AC!        do ep=-2,0
!AC!           c0t(ep)=gC0(real(V1,ki_gol),real(V2,ki_gol),&
!AC!           &        real(V3,ki_gol),real(m0,ki_gol),&
!AC!           &        real(m1,ki_gol),real(m2,ki_gol),&
!AC!           &        real(scale2,ki_gol),ep)
!AC!        end do
!AC!        !c0t( 0) = c0t(0) + log(scale2) * (c0t(-1) &
!AC!        !      & + 0.5_ki * log(scale2) * c0t(-2))
!AC!        !c0t(-1) = c0t(-1) + log(scale2) * c0t(-2)
!AC!        do ep=-2,0
!AC!           if (verbosity.ge.2) write(iout,1) 'I3(',cut3,',',ep,&
!AC!             & ') = (',real(c0t(ep)),',',aimag(c0t(ep)),'  )' 
!AC!        end do
!AC!        tot3(:) = c0t(:) * c30
            print*, "isca=3: Golem95 not available"
            stop
      elseif (isca.eq.4) then
!AC!        tot3(-2) = 0
!AC!        tot3(-1) = 0
!AC!        tot3(0) = 0
!AC!        call gtrunc(abs(V1)+abs(V2)+abs(V3), V1,V2,V3,m0,m1,m2)
!AC!        ep = -dim(0, int(getlambda()))
!AC!        ctmp=C0(real(V1,ki_lt),real(V2,ki_lt),real(V3,ki_lt),&
!AC!        &         real(m0,ki_lt),real(m1,ki_lt),real(m2,ki_lt))
!AC!        tot3(ep)=c30*ctmp 
!AC!        if (verbosity.ge.2) write(iout,1) &
!AC!       &'I3(',cut3,',',ep,') = (',real(ctmp),',',aimag(ctmp),'  )'
             print*, "isca=4: LoopTools not available"
             stop
      else
         print*, 'error in add3'
         stop
      endif
         tot3(0)=tot3(0) + tot3r
  end subroutine add3

  subroutine add2(nleg,c2,cut2,k1,k2,msq,tot2,tot2r,scale2)
      implicit none
      integer :: cut2,i1,i2,nleg
      real(ki), dimension(0:nleg-1) :: msq
      real(ki) :: scale2, m0, m1, K11, K12, B06
      real(ki), dimension(4):: k1, k2
      complex(ki), dimension(-2:0), intent(out) :: tot2
      complex(ki), dimension(0:9), intent(in) :: c2
      complex(ki), intent(out) :: tot2r
      integer :: ep
      complex(ki), dimension(-2:0) :: J0, J1, J00, J01, J11 
          complex(ki_avh), dimension(0:2) :: scf2, scf1, scf0, scf 
          complex(ki) :: xbb, xb0, xb00
          real(ki) :: bkv
          integer :: i

      if (isca .eq. 2) then
       if (notfirsti.eqv.(.false.)) then
             call avh_olo_mu_set(real(sqrt(scale2),ki_avh))
         notfirsti=.true.
       endif
      endif

      i2=cut2/10
      i1=cut2-i2*10

      m0=msq(i1)
      m1=msq(i2)

      K11=sdot(K1,K1)
      K12=sdot(K1,K2)


      B06=-(K11-three*(m0+m1))/six

      tot2r= + B06*c2(9)

      if (isca.eq.1) then
          do ep=-2,0
             J00(ep)=qlI2(real(K11,ki_ql),real(m0,ki_ql),real(m0,ki_ql),&
             &            real(scale2,ki_ql),ep)
             J11(ep)=qlI2(real(K11,ki_ql),real(m1,ki_ql),real(m1,ki_ql),&
             &            real(scale2,ki_ql),ep)
             J01(ep)=qlI2(real(K11,ki_ql),real(m0,ki_ql),real(m1,ki_ql),&
             &            real(scale2,ki_ql),ep)
             J0(ep)=qlI1(real(m0,ki_ql),real(scale2,ki_ql),ep)
             J1(ep)=qlI1(real(m1,ki_ql),real(scale2,ki_ql),ep)
          enddo
          ! The remaining steps come in another if-statement
!AC!      print*, "isca=1: QCDLoop not available"
!AC!      stop
       elseif  (isca.eq.2) then
             xbb=c2(0)
             xb0=c2(1)
             xb00=c2(2)
             bkv=K12
             call avh_olo_b11m(scf2,scf0,scf1,scf,real(K11,ki_avh),&
             &                 real(m0,ki_avh),real(m1,ki_avh))
             tot2(0)=xbb*scf(0)+xb0*bkv*scf1(0)+xb00*bkv*bkv*scf2(0)
             tot2(0)=tot2(0)+ B06*c2(9)
             tot2(-1)=xbb*scf(1)+xb0*bkv*scf1(1)+xb00*bkv*bkv*scf2(1)
             tot2(-2)=xbb*scf(2)+xb0*bkv*scf1(2)+xb00*bkv*bkv*scf2(2)
              if (verbosity.ge.2) then
                 do i=0,2
                    write(iout,903) 'B_0 (',cut2,',',-i,') = ',scf(i)
                    write(iout,903) 'B_1 (',cut2,',',-i,') =',scf1(i)
                    write(iout,903) 'B_11(',cut2,',',-i,') =',scf2(i)
                 enddo
              endif
!AC!      print*, "isca=2: OneLOop not available"
!AC!      stop
      elseif (isca.eq.3) then
!AC!        call gtrunc(abs(K11)+1.0_ki, K11,m0,m1)
!AC!        do ep=-2,0
!AC!           J00(ep)= gB0(real(K11,ki_gol),&
!AC!           &           real(m0,ki_gol),real(m0,ki_gol),&
!AC!           &           real(scale2,ki_gol),ep)
!AC!           J11(ep)= gB0(real(K11,ki_gol),&
!AC!           &           real(m1,ki_gol),real(m1,ki_gol),&
!AC!           &           real(scale2,ki_gol),ep)
!AC!           J01(ep)= gB0(real(K11,ki_gol),&
!AC!           &           real(m0,ki_gol),real(m1,ki_gol),&
!AC!           &           real(scale2,ki_gol),ep)
!AC!           J0(ep) = gA0(real(m0,ki_gol),&
!AC!           &           real(scale2,ki_gol),ep)
!AC!           J1(ep) = gA0(real(m1,ki_gol),&
!AC!           &           real(scale2,ki_gol),ep)
!AC!         end do
!AC!         !J00( 0) = J00(0) + log(scale2) * (J00(-1) &
!AC!         !     & + 0.5_ki * log(scale2) * J00(-2))
!AC!         !J00(-1) = J00(-1) + log(scale2) * J00(-2)
!AC!         !J01( 0) = J01(0) + log(scale2) * (J01(-1) &
!AC!         !     & + 0.5_ki * log(scale2) * J01(-2))
!AC!         !J01(-1) = J01(-1) + log(scale2) * J01(-2)
!AC!         !J11( 0) = J11(0) + log(scale2) * (J11(-1) &
!AC!         !     & + 0.5_ki * log(scale2) * J11(-2))
!AC!         !J11(-1) = J11(-1) + log(scale2) * J11(-2)
!AC!         !J0( 0) = J0(0) + log(scale2) * (J0(-1) &
!AC!         !     & + 0.5_ki * log(scale2) * J0(-2))
!AC!         !J0(-1) = J0(-1) + log(scale2) * J0(-2)
!AC!         !J1( 0) = J1(0) + log(scale2) * (J1(-1) &
!AC!         !     & + 0.5_ki * log(scale2) * J1(-2))
!AC!         !J1(-1) = J1(-1) + log(scale2) * J1(-2)
             print*, "isca=3: Golem95 not available"
             stop
      elseif (isca.eq.4) then
!AC!        call gtrunc(abs(K11)+1.0_ki, K11,m0,m1)
!AC!        J00(:) = 0.0_ki_lt
!AC!        J11(:) = 0.0_ki_lt
!AC!        J0(:) = 0.0_ki_lt
!AC!        J1(:) = 0.0_ki_lt
!AC!        ep = -dim(0, int(getlambda()))
!AC!        J00(ep) = B0(real(K11,ki_lt),real(m0,ki_lt),real(m0,ki_lt))
!AC!        J11(ep) = B0(real(K11,ki_lt),real(m1,ki_lt),real(m1,ki_lt))
!AC!        J01(ep) = B0(real(K11,ki_lt),real(m0,ki_lt),real(m1,ki_lt))
!AC!        J0(ep)  = A0(real(m0,ki_lt))
!AC!        J1(ep)  = A0(real(m1,ki_lt))
            print*, "isca=4: LoopTools not available"
            stop
       else
          print*, 'error in add2'
          stop
       endif

       if (isca.eq.1 .or. isca.eq.3 .or. isca.eq.4) then
          if (abs(K11).gt.zip1) then
             do ep=-2,0
                tot2(ep)=-(K12*(two*K12*(m0 - m1)*c2(2) +  &
        &         K11*(-three*c2(1) + two*K12*c2(2)))*J0(ep))/(six*K11**2) &
        &         + ((two*K12**2*(m0 - m1)**2*c2(2) +  &
        &         K11*K12*(-three*m0*c2(1) + three*m1*c2(1) +  &
        &         two*K12*m0*c2(2) - four*K12*m1*c2(2)) +  &
        &         K11**2*(6*c2(0) + K12*(-three*c2(1) + two*K12*c2(2))))* &
        &         J01(ep))/(six*K11**2) +  &
        &         (K12*(two*K12*(m0 - m1)*c2(2) +  &
        &         K11*(-three*c2(1) + four*K12*c2(2)))*J1(ep))/(six*K11**2)
             enddo
             tot2(0)=tot2(0)+(K12**2*c2(2))/18.0_ki &
        &       - (K12**2*m0*c2(2))/(six*K11) -  &
        &       (K12**2*m1*c2(2))/(six*K11) + B06*c2(9)
          else
             if (m1.eq.m0) then
                do ep=-2,0
                   tot2(ep)=(c2(0) + (K12*(-three*c2(1) &
        &                    + two*K12*c2(2)))/six)*J00(ep)
                enddo
                tot2(0)=tot2(0)+B06*c2(9)
             else
                do ep=-2,0
                   tot2(ep)=(K12*m0**2*(-three*m0*c2(1) + three*m1*c2(1) &
        &              + two*K12*m0*c2(2))* &
        &              J00(ep))/(six*(m0 - m1)**3) + c2(0)*J01(ep) -  &
        &              (K12*m1*(m0*m1*(9*c2(1) - 6*K12*c2(2)) -  &
        &              6*m0**2*(c2(1) - K12*c2(2)) +  &
        &              m1**2*(-three*c2(1) + two*K12*c2(2)))*J11(ep))/ &
        &              (six*(m0 - m1)**3)
                enddo
                tot2(0)=tot2(0) + (-three*K12*m0*c2(1))/(four*(m0 - m1)) +  &
        &           (K12*m1*c2(1))/(four*m0 - four*m1) +  &
        &           (11.0_ki*K12**2*m0**2*c2(2))/(18.0_ki*(m0 - m1)**2) -  &
        &           (7.0_ki*K12**2*m0*m1*c2(2))/(18.0_ki*(m0 - m1)**2) +  &
        &           (K12**2*m1**2*c2(2))/(9.0_ki*(m0 - m1)**2) + B06*c2(9)
             endif
          endif
          if (verbosity.ge.2) then
             do ep=0,2
                write(iout,903) 'B0 (',cut2,',',-ep,') = ',J0(-ep)
                write(iout,903) 'B1 (',cut2,',',-ep,') =',J1(-ep)
                write(iout,903) 'B00(',cut2,',',-ep,') =',J00(-ep)
                write(iout,903) 'B11(',cut2,',',-ep,') =',J11(-ep)
             end do
          endif
       end if
 903   format(a5,I2,a1,I2,a4,2(D24.15))

  end subroutine add2

  subroutine add1(nleg,c1,cut1,msq,tot1,scale2)
      implicit none 
      integer, intent(in) :: nleg, cut1
      complex(ki), dimension(-2:0), intent(out) :: tot1
      complex(ki), dimension(0:4), intent(in) :: c1
      real(ki), dimension(0:nleg-1), intent(in) :: msq
      real(ki), intent(in) :: scale2
      integer ::j1
      real(ki) :: m0
          complex(ki_avh), dimension(0:2) :: vala0
      complex(ki) :: ctmp
      integer :: ep

      if (isca .eq. 2) then
       if (notfirsti.eqv.(.false.)) then
             call avh_olo_mu_set(real(sqrt(scale2),ki_avh))
         notfirsti=.true.
       endif
      endif
      j1=cut1

      m0=msq(j1)

  1   Format(A3,I2,A1,I2,A5,D24.15,A1,D24.15,A3)

      if      (isca.eq.1) then
             do ep=-2,0
                ctmp = qlI1(real(m0,ki_ql),real(scale2,ki_ql),ep)
                tot1(ep)=c1(0)*ctmp
                if (verbosity.ge.2) write(iout,1) &
         & 'I1(',cut1,',',ep,') = (',real(ctmp),',',aimag(ctmp),'  )' 
             enddo
!AC!      print*, "isca=1: QCDLoop not available"
!AC!      stop
      elseif  (isca.eq.2) then         
             call avh_olo_a0m(vala0,real(m0,ki_avh))
             do ep=-2,0
                tot1(ep)= c1(0)*vala0(-ep) 
                if (verbosity.ge.2) write(iout,1) &
         & 'I1(',cut1,',',ep,') = (',real(vala0(-ep)),',',aimag(vala0(-ep)),'  )' 
             enddo
!AC!      print*, "isca=2: OneLOop not available"
!AC!      stop
      elseif (isca.eq.3) then
!AC!        call gtrunc(1.0_ki, m0)
!AC!         tot1(-2) = (0.0_ki,0.0_ki)
!AC!            if (verbosity.ge.2) write(iout,1) &
!AC!     & 'I1(',cut1,',',-2,') = (',0.0_ki,',',0.0_ki,'  )' 
!AC!         do ep=-1,0
!AC!            ctmp = gA0(real(m0,ki_gol),&
!AC!           &        real(scale2,ki_gol),ep)
!AC!            tot1(ep) = c1(0)*ctmp
!AC!            if (verbosity.ge.2) write(iout,1) &
!AC!     & 'I1(',cut1,',',ep,') = (',real(ctmp),',',aimag(ctmp),'  )' 
!AC!         enddo
             print*, "isca=3: Golem95 not available"
             stop
      elseif (isca.eq.4) then
!AC!        tot1(-2) = 0
!AC!        tot1(-1) = 0
!AC!        tot1(0) = 0
!AC!        ep = -dim(0, int(getlambda()))
!AC!        ctmp = A0(real(m0,ki_lt))
!AC!        tot1(ep)=c1(0)*ctmp
!AC!        if (verbosity.ge.2) write(iout,1) &
!AC!     & 'I1(',cut1,',',ep,') = (',real(ctmp),',',aimag(ctmp),'  )' 
             print*, "isca=4: LoopTools not available"
             stop
      else
         print*, 'error in add1'
         stop
      endif

  end subroutine add1

!AC!function gA0(m0,mu2,ep)
!AC!   implicit none
!AC!   real(ki_gol), intent(in) :: m0, mu2
!AC!   integer, intent(in) :: ep
!AC!   complex(ki_gol) :: gA0
!AC!   if(ep.eq.(-2) .or. m0.eq.0.0_ki_gol) then
!AC!      gA0 = (0.0_ki_gol, 0.0_ki_gol)
!AC!   elseif(ep.eq.(-1)) then
!AC!      gA0 = m0 * gB0(0.0_ki_gol,&
!AC!          &        real(m0,ki_gol),real(m0,ki_gol),&
!AC!          &        real(mu2,ki_gol),-1)
!AC!   else
!AC!      gA0 = m0 * (gB0(0.0_ki_gol,&
!AC!          &        real(m0,ki_gol),real(m0,ki_gol),&
!AC!          &        real(mu2,ki_gol),0) &
!AC!          &    +  gB0(0.0_ki_gol,&
!AC!          &        real(m0,ki_gol),real(m0,ki_gol),&
!AC!          &        real(mu2,ki_gol),-1))
!AC!   end if
!AC!end function gA0

!AC!pure subroutine gtrunc(ref,s1,s2,s3,s4,s5,s6,s7,s8,s9,s10)
!AC!   implicit none
!AC!   real(ki), intent(in) :: ref
!AC!   real(ki), intent(inout), optional :: s1,s2,s3,s4,s5,s6,s7,s8,s9,s10
!AC!   real(ki), parameter :: small = 1.0E-08_ki
!AC!   if(present(s1)) then
!AC!      if(abs(s1/ref) .lt. small) s1 = 0.0_ki
!AC!   end if
!AC!   if(present(s2)) then
!AC!      if(abs(s2/ref) .lt. small) s2 = 0.0_ki
!AC!   end if
!AC!   if(present(s3)) then
!AC!      if(abs(s3/ref) .lt. small) s3 = 0.0_ki
!AC!   end if
!AC!   if(present(s4)) then
!AC!      if(abs(s4/ref) .lt. small) s4 = 0.0_ki
!AC!   end if
!AC!   if(present(s5)) then
!AC!      if(abs(s5/ref) .lt. small) s5 = 0.0_ki
!AC!   end if
!AC!   if(present(s6)) then
!AC!      if(abs(s6/ref) .lt. small) s6 = 0.0_ki
!AC!   end if
!AC!   if(present(s7)) then
!AC!      if(abs(s7/ref) .lt. small) s7 = 0.0_ki
!AC!   end if
!AC!   if(present(s8)) then
!AC!      if(abs(s8/ref) .lt. small) s8 = 0.0_ki
!AC!   end if
!AC!   if(present(s9)) then
!AC!      if(abs(s9/ref) .lt. small) s9 = 0.0_ki
!AC!   end if
!AC!   if(present(s10)) then
!AC!      if(abs(s10/ref) .lt. small) s10 = 0.0_ki
!AC!   end if
!AC!end  subroutine gtrunc

end module madds

